<?php
class ControllerSaleSaleOrder extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('sale/order');
		$this->load->model('sale/sale_order');
		
		$data['bar_categories'] = $this->model_sale_sale_order->getCategories('59');
		$data['food_categories'] = $this->model_sale_sale_order->getCategories('60');
		$data['products'] = $this->model_sale_sale_order->getProducts();
		


		$this->document->setTitle($this->language->get('heading_title'));
		
		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('sale/sale_order', $data));


		}

}
