/************************************************************/
/***********************customer auto complete***************/
/************************************************************/
var customers = TAFFY();

customers.insert(customer);


var customer_name_autofill = [];

var customer_number_autofill = [];

var customer_email_autofill = [];

for (var i = 0; i < customer.length; i++) {

    var a = {
        "label": customer[i].firstname,
        "value": customer[i].customer_id
    };

    var b = {
        "label": customer[i].telephone,
        "value": customer[i].customer_id
    };

    var c = {
        "label": customer[i].email,
        "value": customer[i].customer_id
    };

    customer_name_autofill.push(a);
    customer_number_autofill.push(b);
    customer_email_autofill.push(c);
}


function set_customer(customer_id) {
    var a = customers({
        customer_id: customer_id
    }).get();

    $("#customer_name").val(a[0].firstname);
    $("#customer_number").val(a[0].telephone);
    $("#customer_email").val(a[0].email);
    $("#customer_id").val(a[0].customer_id);
}

$('#customer_name').autocomplete({
    'source': function(request, response) {
        var results = $.ui.autocomplete.filter(customer_name_autofill, request.term);

        response(results.slice(0, 10));
    },
    'select': function(event, ui) {
        set_customer(ui.item.value);
        return false;
    }
});


$('#customer_number').autocomplete({
    'source': function(request, response) {
        var results = $.ui.autocomplete.filter(customer_number_autofill, request.term);

        response(results.slice(0, 10));
    },
    'select': function(event, ui) {
        set_customer(ui.item.value);
        return false;
    }
});


$('#customer_email').autocomplete({
    'source': function(request, response) {
        var results = $.ui.autocomplete.filter(customer_email_autofill, request.term);

        response(results.slice(0, 10));
    },
    'select': function(event, ui) {
        set_customer(ui.item.value);
        return false;
    }
});


/************************************************************/
/***********************customer auto complete***************/
/************************************************************/


var bm_cid = ['62'];
var fm_cid = [];
var sm_cid = [];


var kots = TAFFY();
kots.insert(open_kots);

var kot_products = TAFFY();
kot_products.insert(kot_data);
var my_cart = [];



$(document).ready(function(e) {

    $("#open_kot_list").find("tbody").html("");
    var c_kot = kots().order("kot_id").get();

    var sno = $("#open_kot_list").find("tbody").find("tr").length + 1;
    var html;

    for (var i = 0; i < c_kot.length; i++) {
        var t = tConvert(c_kot[i].time);

        html += "<tr><td>" + sno + "</td><td style='text-align:center'>" + c_kot[i].kot_id + "</td><td class='open_kot_time'>" + t + "</td><td><a class='view_kot' style='font-size:14px; cursor:pointer' data-kot-id='" + c_kot[i].kot_id + "'>view / print</a></td></tr>";
        sno++;
    }


    $("#open_kot_list").find("tbody").html(html);




    $(".category_list li").click(function() {

        $(".category_list li").removeClass("active");
        $(this).addClass("active");
        var category_id = $(this).attr("id");
        $(".product_list li").each(function(index, element) {
            if ($(this).attr("data-cid") == category_id) {
                $(this).fadeIn();
            } else {
                $(this).fadeOut();
            }
        });
    })



    $(".product_list li").click(function() {

        $(this).addClass("added");
        var pid = $(this).attr("data-pid");

        if (my_cart.indexOf(pid) != -1) {
            $("#bill_body tr").each(function(index, element) {
                if ($(this).find(".p_id").val() == pid) {
                    $(this).find(".add_qty").click();
                }
            });
        } else {

            var cid = $(this).attr("data-cid");

            var pname = $(this).find("span").html();
            var price = $(this).attr("data-price");
            var tax = $(this).attr("data-tax");
            var sno = $("#bill_body tr").length + 1;
            var qty = 1;

            var html = "<tr><input type='hidden' class='p_tax' value='" + tax + "' /><input type='hidden' class='p_id' value='" + pid + "' /><input type='hidden' class='c_id' value='" + cid + "' /><td class='sno'>" + sno + "</td><td class='p_name'><b>" + String(pname).toUpperCase() + "</b></td><td class='p_price'>" + Number(price).toFixed(2) + "</td><td class='p_qty'><li class='fa fa-plus-circle add_qty'></li>&nbsp;&nbsp;<font>" + qty + "</font>&nbsp;&nbsp;<li class='fa fa-minus-circle less_qty'></li></td><td class='p_total'>" + Number(price).toFixed(2) + "</td><td class='p_remove' style='text-align:center'><li class='fa fa-close remove_product'></li></td></tr>";
            $("#bill_body").append(html);
            update_total();

            my_cart.push(pid);

        }

    })



    function update_total() {
        var total = 0;
        $("#bill_body tr").each(function(index, element) {
            total = total + Number($(this).find(".p_total").html());
        });
        $("#grand_total font").html(total.toFixed(2));
    }


    $("body").on("click", ".less_qty", function() {
        var qty = Number($(this).parent().find("font").html());
        if (qty > 1) {
            qty = qty - 1;
            var price = Number($(this).parent().siblings(".p_price").html());
            var total = price * qty;

            $(this).parent().find("font").html(qty);
            $(this).parent().siblings(".p_total").html(total.toFixed(2));
            update_total();
        } else {
            $(this).parent().siblings(".p_remove").find(".remove_product").click()
        }
    })


    $("body").on("click", ".add_qty", function() {
        var qty = Number($(this).parent().find("font").html());
        qty = qty + 1;
        var price = Number($(this).parent().siblings(".p_price").html());
        var total = price * qty;

        $(this).parent().find("font").html(qty);
        $(this).parent().siblings(".p_total").html(total.toFixed(2));
        update_total();
    })

    $("body").on("click", ".remove_product", function() {

        var id = $(this).parent().parent().find(".p_id").val();

        $(".product_list li").each(function(index, element) {
            if ($(this).attr("data-pid") == id) {
                $(this).removeClass("added");
            }
        });

        $(this).parent().parent().remove();
        update_total();
        update_sno();
    })

    function update_sno() {
        var i = 1;
        $("#bill_body tr").each(function(index, element) {
            $(this).find(".sno").html(i);
            i++;
        });
    }


  $(".category_list").eq(0).find("li").eq(0).click();


});



////////////////////////////////////////kot functions////////////////////////////////////


////////////////////////////////////////save & print kot functions/////////////////////////


$("#save_kot").click(function() {

    if (!$("#order_source_id").val()) {
        alert("please choose order type");
        $("#order_source_id").focus();
        return false;

    }

    var today = new Date();
    var dd = today.getDate();
    var mm = today.getMonth() + 1;
    var yyyy = today.getFullYear();
    var t = today.getHours();
    var m = today.getMinutes();
    var s = today.getSeconds();

    if (dd < 10) {
        dd = '0' + dd
    }

    if (mm < 10) {
        mm = '0' + mm
    }

    if (t < 10) {
        t = '0' + t
    }

    if (m < 10) {
        m = '0' + m
    }

    if (s < 10) {
        s = '0' + s
    }

    today = dd + '/' + mm + '/' + yyyy;
    var time = t + ':' + m + ':' + s;

    var open_time = time;
    var open_date = today;

    if (!$("#bill_body tr").length) {
        alert("Please add at leaset 1 item!");
        return 0;
    }

    //setting kot

    var set_form = new Promise(function save_order(resolve, reject) {

        $("#tw_customer_email").val($("#customer_email").val());
        $("#tw_customer_name").val($("#customer_name").val());
        $("#tw_customer_number").val($("#customer_number").val());
        $("#tw_customer_id").val($("#customer_id").val());

        $("#order_source_id1").val($("#order_source_id").val());

        $("#tw_open_by").val(open_by);
        $("#tw_date").val(open_date);
        $("#tw_open_time").val(open_time);
        $("#tw_kot_total").val($("#grand_total font").html());


        var html;

        $("#bill_body tr").each(function(index, element) {
            var p_id = $(this).find(".p_id").val();
            var c_id = $(this).find(".c_id").val();
            var p_tax = $(this).find(".p_tax").val();


            var p_name = $(this).find(".p_name").text();
            var p_price = $(this).find(".p_price").html();
            var p_qty = $(this).find(".p_qty font").html();

            html += "<input name='product_id[]' class='remove_input' value='" + p_id + "'>";
            html += "<input name='category_id[]' class='remove_input' value='" + c_id + "'>";
            html += "<input name='product_name[]' class='remove_input' value='" + p_name + "'>";
            html += "<input name='product_price[]' class='remove_input' value='" + p_price + "'>";
            html += "<input name='product_qty[]' class='remove_input' value='" + p_qty + "'>";
            html += "<input name='product_tax[]' class='remove_input' value='" + p_tax + "'>";


        });
        $("#takeaway_form").append(html);

        resolve($("#takeaway_form").serialize());
    })

    set_form.then(submit_takeaway_form);
    reset_kot();


})


$("#bm_kot_print").click(function() {
    $("#kot_product_body tr").each(function(index, element) {
        if (bm_cid.indexOf($(this).attr("data-category-id")) > -1) {
            $(this).removeClass("print_hide");
        }
    });

    window.print();
})

////////////////////////////////////////save & print kot functions end/////////////////////////

function submit_takeaway_form(data) {

    var form_data = data;
    $.ajax({
        url: 'index.php?route=sale/takeaway_kot/save_takeaway&token=' + token,
        type: "POST",
        data: form_data,
        success: function(data) {
            console.log(data);

            data = JSON.parse(data);

            kots.insert(data.last_kot);
            kot_products.insert(data.last_kot_products);

            refresh_current_kot_list();

        }
    }).done(function() {
        while (my_cart.length) {
            my_cart.pop();
        }

    });

}


function refresh_current_kot_list(kot_id, time, status) {
    $("#open_kot_list").find("tbody").html("");

    var c_kot = kots().order("kot_id").get();

    var sno = $("#open_kot_list").find("tbody").find("tr").length + 1;
    var html;

    for (var i = 0; i < c_kot.length; i++) {
        var t = tConvert(c_kot[i].time);

        html += "<tr><td>" + sno + "</td><td style='text-align:center'>" + c_kot[i].kot_id + "</td><td class='open_kot_time'>" + t + "</td><td><a class='view_kot' style='font-size:14px; cursor:pointer' data-kot-id='" + c_kot[i].kot_id + "'>view / print</a></td></tr>";
        sno++;

    }
    $("#open_kot_list").find("tbody").html(html);
    $("#kot_watch").animate({
        scrollTop: $('#kot_watch').prop("scrollHeight")
    }, 1000);
}

function reset_kot() {
    $(".product_list li").removeClass("added");
    $("#bill_body").empty();
    $("#grand_total font").html("0");
    $(".reset_input").val("");
    $('select.reset_input').prop('selectedIndex', 0);
    $(".remove_input").remove();

}


$("body").on("click", ".view_kot", function() {

    var kot_i = $(this).attr('data-kot-id');
    var table_id = $(".current_table").attr("data-table-id");
    var kot_time = $(this).parent().siblings('.open_kot_time').html();


    var kot_p = kot_products({
        kot_id: kot_i
    }).get();

    console.log(kot_p);

    var html;

    for (var i = 0; i < kot_p.length; i++) {

        if (bm_cid.indexOf(kot_p[i].category_id) > -1) {
            $("#bm_kot_print").fadeIn();
        }
        if (fm_cid.indexOf(kot_p[i].category_id) > -1) {
            $("#fm_kot_print").fadeIn();
        }
        if (sm_cid.indexOf(kot_p[i].category_id) > -1) {
            $("#sm_kot_print").fadeIn();
        }


        html += "<tr class='print_hide' data-category-id='" + kot_p[i].category_id + "'><td><b>" + kot_p[i].name + "</b></td><td><b>" + kot_p[i].quantity + "</b></td></tr>";

    }

    $("#kot_product_body").html(html);

    var today = new Date();
    var dd = today.getDate();
    var mm = today.getMonth() + 1;
    var yyyy = today.getFullYear();

    if (dd < 10) {
        dd = '0' + dd
    }

    if (mm < 10) {
        mm = '0' + mm
    }

    today = dd + '/' + mm + '/' + yyyy;



    $("#k_date").html(today);
    $("#k_time").html(kot_time);
    $("#k_t_id").html(table_id);
    $("#k_number").html(kot_i);

    $("#myModal").modal();

})


$("#myModal").on("hidden.bs.modal", function() {
    $("#bm_kot_print, #sm_kot_print, #fm_kot_print").fadeOut();

});

$("#full_kot_print").click(function() {
    $("#kot_product_body tr").each(function(index, element) {
        $(this).removeClass("print_hide");
    })
    window.print();
})



function tConvert(time) {
    // Check correct time format and split into components
    time = time.toString().match(/^([01]\d|2[0-3])(:)([0-5]\d)(:[0-5]\d)?$/) || [time];
    if (time.length > 1) { // If time format correct
        time = time.slice(1); // Remove full string match value
        time[5] = +time[0] < 12 ? ' AM' : ' PM'; // Set AM/PM
        time[0] = +time[0] % 12 || 12; // Adjust hours
    }
    return time.join(''); // return adjusted time or original string
}

function myFunction() {
    // Declare variables
    var input, filter, ul, li, a, i;
    input = document.getElementById('myInput');
    filter = input.value.toUpperCase();
    ul = document.getElementById("myUL");
    li = ul.getElementsByTagName('li');

    // Loop through all list items, and hide those who don't match the search query
    for (i = 0; i < li.length; i++) {
        a = li[i];
        if (a.innerHTML.toUpperCase().indexOf(filter) > -1) {
            li[i].style.display = "";
        } else {
            li[i].style.display = "none";
        }
    }
}