<?php
class ControllerSaleEditOrder extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('sale/order');
		$data['refresh']=0;
		
		
		$this->load->model('sale/sale_order');
		$this->load->model('sale/view_order');
		$this->load->model('user/user');
		
	
	
		$data['username'] = $this->user->getUserName();
		$data['user_id'] = $this->user->getId();
		$userid=$this->user->getId();

		$user = $this->model_user_user->getUser($userid);
		$data['user_group']= $user['user_group_id'];

		
		if(isset($this->request->post['clear_form'])){
			
			if(isset($this->request->post['table_bill_id'])){
			
				for($i=0; $i<sizeof($_POST['table_bill_id']); $i++){
			      $this->model_sale_view_order->eraseTableBills($_POST['table_bill_id'][$i]);
								}
			
			}
			
			if(isset($this->request->post['takeaway_bill_id'])){
				//print_r($this->request->post['takeaway_bill_id']);
				for($i=0; $i<sizeof($_POST['takeaway_bill_id']); $i++){
	       		$this->model_sale_view_order->eraseTakeawayBills($_POST['takeaway_bill_id'][$i]);
				}
			}
		}
		
		if(isset($this->request->post['today_date'])){
		$date =  $this->request->post['today_date'];
			
			}else{
				
		$date =  date("Y-m-d");
				}
		
		
		$data['date']= $date;
		
		if(isset($_POST['refresh_form'])){
	  	$data['table_bills'] = $table_bills = $this->model_sale_view_order->getAllTablesRefresh($date);
		$data['refresh']=1;
			
			}else{
	  	$data['table_bills'] = $table_bills = $this->model_sale_view_order->getAllTables($date);
				
				}
		
	 	
		$table_bill_ids = array();
		
		for($i=0; $i < sizeof($table_bills); $i++){
			$table_bill_ids[$i]= $table_bills[$i]['table_bill_id'];
			}
		
		if(sizeof($table_bill_ids)>0){
		$table_bill_ids = implode(",",$table_bill_ids);
			}else{
		$table_bill_ids = 0;
				}
		
		
		$data['table_bills_products']= $table_bill_products = $this->model_sale_view_order->getTableProducts($table_bill_ids);
		
		 ///takeaway kot data/////
	 
	   
	   $data['bills_swiggy'] = $bills_swiggy = $this->model_sale_view_order->getSwiggyBills($date);
	   $data['bills_takeaway'] = $bills_takeaway = $this->model_sale_view_order->getTakeawayBills($date);
	   $data['bills_home'] = $bills_home = $this->model_sale_view_order->getHomeBills($date);
	
	
	    $data['payment_methods'] = $this->model_sale_sale_order->getPaymentMethods();
	    $data['waiters'] = $this->model_sale_sale_order->getWaiters();
	    $data['customer'] = $this->model_sale_sale_order->getSaleCustomer();	
	
	
	   $bill_ids_swiggy = array();
	   $bill_ids_takeaway = array();
	   $bill_ids_home = array();
		
		for($i=0; $i < sizeof($bills_swiggy); $i++){
			$bill_ids_swiggy[$i]= $bills_swiggy[$i]['takeaway_bill_id'];
			}
	
		
		for($i=0; $i < sizeof($bills_takeaway); $i++){
			$bill_ids_takeaway[$i]= $bills_takeaway[$i]['takeaway_bill_id'];
			}
	
		for($i=0; $i < sizeof($bills_home); $i++){
			$bill_ids_home[$i]= $bills_home[$i]['takeaway_bill_id'];
			}
	
		
		if(sizeof($bill_ids_takeaway)>0){
		$bill_ids_takeaway = implode(",",$bill_ids_takeaway);
			}else{
		$bill_ids_takeaway = 0;
				}
		
		if(sizeof($bill_ids_home)>0){
		$bill_ids_home = implode(",",$bill_ids_home);
			}else{
		$bill_ids_home = 0;
				}
				
		
		if(sizeof($bill_ids_swiggy)>0){
		$bill_ids_swiggy = implode(",",$bill_ids_swiggy);
			}else{
		$bill_ids_swiggy = 0;
				}
				
				
	
		$data['product_data_swiggy'] = $this->model_sale_view_order->getTakeawayProducts($bill_ids_swiggy);
		$data['product_data_takeaway'] = $this->model_sale_view_order->getTakeawayProducts($bill_ids_takeaway);
		$data['product_data_home'] = $this->model_sale_view_order->getTakeawayProducts($bill_ids_home);
	    
		
	
	

		$this->document->setTitle("View Saved Bill");
		
		$data['token'] = $this->session->data['token'];
		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('sale/view_order', $data));


		}
		
		public function save_bill(){
	  
				$this->load->model('sale/sale_order');
	      
			
			//add customer
			
			$customer_id = $this->request->post['customer_id'];
			$customer_name = $this->request->post['customer_name'];
			$customer_email = $this->request->post['customer_email'];
			$customer_phone = $this->request->post['customer_number'];
			
			
			if($customer_id==0 || $customer_id==''){
				if(!empty($customer_name) && !empty($customer_phone)){
				  $customer_id = $this->model_sale_sale_order->addCustomer($customer_name, $customer_email, $customer_phone);	
					}
				}
			
			    $data['customer_id']= $customer_id;
				$data['erase_flag']= $this->request->post['erase_flag'];
				$data['served_by']= $this->request->post['waiter_id'];
				
				$data['created_by']= $this->request->post['created_by'];
				$data['date']= $this->request->post['date'];
				$data['time']= $this->request->post['time'];
				$data['grand_total']= $this->request->post['grand_total'];
				$data['service_charges']= $this->request->post['service_charges'];
				
				$data['discount']= $this->request->post['discount'];
				$data['payment_method']= $this->request->post['payment_method'];
				$data['table_id']= $this->request->post['table_id'];
				$data['table_order_id']= $this->request->post['table_order_id'];
				$data['takeaway_order_id']= $this->request->post['takeaway_order_id'];
				
				$data['order_source']= $this->request->post['order_source'];
				
				
				$data['product_id']= $this->request->post['product_id'];
				$data['product_name']= $this->request->post['product_name'];
				$data['product_price']= $this->request->post['product_price'];
				$data['product_qty']= $this->request->post['product_qty'];
				
				
			
			if($this->request->post['table_id']!=0 || !empty($this->request->post['table_id'])){
				$this->model_sale_sale_order->save_table_bill($data);
				}else{
				$this->model_sale_sale_order->save_takeaway_bill($data);
					}	
		
		
		
	//	return 
		
			}

		

}
