var my_cart = [];

taken_tables = JSON.parse(taken_tables);

if (taken_tables.length > 0) {
    for (var i = 0; i < taken_tables.length; i++) {
        var table_id = taken_tables[i].table_id;
        var table_order_id = taken_tables[i].table_order_id;

        $(".table-btn[data-table-id='" + table_id + "']").addClass('table-taken');
        $(".table-btn[data-table-id='" + table_id + "']").attr('data-table-status', 'open');
        $(".table-btn[data-table-id='" + table_id + "']").attr('data-table-order-id', table_order_id);

    }

}



$(document).ready(function(e) {
    $("#column-left").animate({
        left: "-260px"
    })

    $("#open_left").click(function() {
        $("#column-left").animate({
            left: "0px"
        })
    })

    $(".category_list li").click(function() {

        $(".category_list li").removeClass("active");
        $(this).addClass("active");
        var category_id = $(this).attr("id");
        $(".product_list li").each(function(index, element) {
            if ($(this).attr("data-cid") == category_id) {
                $(this).fadeIn();
            } else {
                $(this).fadeOut();
            }
        });
    })



    $(".product_list li").click(function() {

        if ($(".current_table").length !== 1) {
            alert("please choose a table");
            return 0;
        }

        $(this).addClass("added");
        var pid = $(this).attr("data-pid");

        if (my_cart.indexOf(pid) != -1) {
            $("#bill_body tr").each(function(index, element) {
                if ($(this).find(".p_id").val() == pid) {
                    $(this).find(".add_qty").click();
                }
            });
        } else {

            var cid = $(this).attr("data-cid");

            var pname = $(this).find("span").html();
            var price = $(this).attr("data-price");
            var tax = $(this).attr("data-tax");
            var sno = $("#bill_body tr").length + 1;
            var qty = 1;

            var html = "<tr><input type='hidden' class='p_id' value='" + pid + "' /><input type='hidden' class='c_id' value='" + cid + "' /><td class='sno'>" + sno + "</td><td class='p_name'><b>" + String(pname).toUpperCase() + "</b></td><td class='p_price'>" + Number(price).toFixed(2) + "</td><td class='p_qty'><li class='fa fa-plus-circle add_qty'></li>&nbsp;&nbsp;<font>" + qty + "</font>&nbsp;&nbsp;<li class='fa fa-minus-circle less_qty'></li></td><td class='p_total'>" + Number(price).toFixed(2) + "</td><td class='p_remove' style='text-align:center'><li class='fa fa-close remove_product'></li></td></tr>";
            $("#bill_body").append(html);
            update_total();

            my_cart.push(pid);

        }

    })



    function update_total() {
        var total = 0;
        $("#bill_body tr").each(function(index, element) {
            total = total + Number($(this).find(".p_total").html());
        });
        $("#grand_total font").html(total.toFixed(2));
    }


    $("body").on("click", ".less_qty", function() {
        var qty = Number($(this).parent().find("font").html());
        if (qty > 1) {
            qty = qty - 1;
            var price = Number($(this).parent().siblings(".p_price").html());
            var total = price * qty;

            $(this).parent().find("font").html(qty);
            $(this).parent().siblings(".p_total").html(total.toFixed(2));
            update_total();
        } else {
            $(this).parent().siblings(".p_remove").find(".remove_product").click()
        }
    })


    $("body").on("click", ".add_qty", function() {
        var qty = Number($(this).parent().find("font").html());
        qty = qty + 1;
        var price = Number($(this).parent().siblings(".p_price").html());
        var total = price * qty;

        $(this).parent().find("font").html(qty);
        $(this).parent().siblings(".p_total").html(total.toFixed(2));
        update_total();
    })

    $("body").on("click", ".remove_product", function() {

        var id = $(this).parent().parent().find(".p_id").val();

        $(".product_list li").each(function(index, element) {
            if ($(this).attr("data-pid") == id) {
                $(this).removeClass("added");
            }
        });

        $(this).parent().parent().remove();
        update_total();
        update_sno();
    })

    function update_sno() {
        var i = 1;
        $("#bill_body tr").each(function(index, element) {
            $(this).find(".sno").html(i);
            i++;
        });
    }


    $(".category_list").eq(0).find("li").eq(0).click();


});

$("body").on("click", ".table-btn", function() {

    $(".table-btn").removeClass("current_table");

    $(this).addClass("current_table");
    update_table_color();
    refresh_current_kot_list();
})


////////////////////////////////////////kot functions/////////////////////////

$("#save_kot").click(function() {
    alert($("#kot_notes").val());
    return false;

    var today = new Date();
    var dd = today.getDate();
    var mm = today.getMonth() + 1;
    var yyyy = today.getFullYear();
    var t = today.getHours();
    var m = today.getMinutes();
    var s = today.getSeconds();

    if (dd < 10) {
        dd = '0' + dd
    }

    if (mm < 10) {
        mm = '0' + mm
    }

    today = dd + '/' + mm + '/' + yyyy;
    var time = t + ':' + m + ':' + s;

    var table_id = $(".current_table").attr("data-table-id");
    var table_status = $(".current_table").attr("data-table-status");
    var open_by = open_by_user ;
    var table_open_time = time;
    var table_open_date = today;

    if (!table_id) {
        alert("Please choose a table!");
        return 0;
    }
    if (!$("#bill_body tr").length) {
        alert("Please add at leaset 1 item!");
        return 0;
    }

    //setting kot

    $("#kot_date").val(today);
    $("#kot_time").val(time);


    //if table is closed


    if (table_status == "close") {

        $("#table_id").val(table_id);
        $("#table_date").val(table_open_date);
        $("#table_open_time").val(table_open_time);
        $("#table_open_by").val(open_by);

        //setting table
        $.ajax({
            url: 'index.php?route=sale/table_kot/save_table_order&token='.token,
            type: "POST",
            data: $("#table_form").serialize(),
            beforeSend: function() {
                $(".table-btn").attr("disabled", "true");

            },
            success: function(data) {
                var table_order_id = data;
                $("#table_order_id_kot_form").val(table_order_id);
                $(".current_table").attr("data-table-order-id", table_order_id);
                $(".current_table").attr("data-table-status", "open");
                $(".current_table").addClass("table_taken");

                $("#current_table_status").html("open");

                //setting kot

                var set_form = new Promise(function save_order(resolve, reject) {

                    var html;

                    $("#bill_body tr").each(function(index, element) {
                        var p_id = $(this).find(".p_id").val();
                        var c_id = $(this).find(".c_id").val();

                        var p_name = $(this).find(".p_name").text();
                        var p_price = $(this).find(".p_price").html();
                        var p_qty = $(this).find(".p_qty font").html();

                        html += "<input name='product_id[]' class='remove_input' value='" + p_id + "'>";
                        html += "<input name='category_id[]' class='remove_input' value='" + c_id + "'>";
                        html += "<input name='product_name[]' class='remove_input' value='" + p_name + "'>";
                        html += "<input name='product_price[]' class='remove_input' value='" + p_price + "'>";
                        html += "<input name='product_qty[]' class='remove_input' value='" + p_qty + "'>";

                    });
                    $("#kot_form").append(html);

                    $("#kot_total").val($("#grand_total font").html());
                    resolve($("#kot_form").serialize());
                })

                set_form.then(submit_kot_form);

                $(".table-btn").attr("disabled", "false");
                $(".table-btn").removeAttr("disabled");
                update_table_color();
                reset_kot();

            }
        })

        //if table is already opened

    } else {
        var set_form = new Promise(function save_order(resolve, reject) {

            var html;


            $("#bill_body tr").each(function(index, element) {
                var p_id = $(this).find(".p_id").val();
                var c_id = $(this).find(".c_id").val();
                var p_name = $(this).find(".p_name").text();
                var p_price = $(this).find(".p_price").html();
                var p_qty = $(this).find(".p_qty font").html();

                html += "<input name='product_id[]' class='remove_input' value='" + p_id + "'>";
                html += "<input name='category_id[]' class='remove_input' value='" + c_id + "'>";
                html += "<input name='product_name[]' class='remove_input' value='" + p_name + "'>";
                html += "<input name='product_price[]' class='remove_input' value='" + p_price + "'>";
                html += "<input name='product_qty[]' class='remove_input' value='" + p_qty + "'>";

            });
            $("#kot_form").append(html);

            $("#table_order_id_kot_form").val($(".current_table").attr("data-table-order-id"));
            $("#kot_total").val($("#grand_total font").html());
            resolve($("#kot_form").serialize());
        })

        set_form.then(submit_kot_form);
        update_table_color();
        reset_kot();

    }
})



function update_table_color() {
    $(".table-btn").each(function(index, element) {
        if ($(this).hasClass("btn-black")) {
            $(this).css("background-color", "#333");
        } else if ($(this).hasClass("table_taken")) {
            $(this).css("background-color", "#E9433E");
        } else {
            $(this).css("background-color", "#4caf50");
        }
    });
}

function refresh_current_kot_list(kot_id, time, status) {
    var current_status = $(".current_table").attr("data-table-status");

    if (current_status == "open") {
        $("#open_kot_list").find("tbody").html("");

        $("#current_table_status").html("open");
        var to_id = $(".current_table").attr("data-table-order-id");
        var c_kot = kots({
            table_order_id: to_id
        }).get();

        var sno = $("#open_kot_list").find("tbody").find("tr").length + 1;
        var html;

        for (var i = 0; i < c_kot.length; i++) {

            html += "<tr><td>" + sno + "</td><td>" + c_kot[i].kot_id + "</td><td>" + c_kot[i].time + "</td><td><a class='view_kot' data-kot-id='" + c_kot[i].kot_id + "'>view</a></td></tr>";
            sno++;
        }


        $("#open_kot_list").find("tbody").html(html);

    } else {
        $("#current_table_status").html("close");
        $("#open_kot_list").find("tbody").html("");

    }
}

function reset_kot() {
    $(".product_list li").removeClass("added");
    $("#bill_body").empty();
    $("#grand_total font").html("0");
    $(".reset_input").val("");
    $(".remove_input").remove();

}

function submit_kot_form(data) {
    var form_data = data;
    $.ajax({
        url: 'index.php?route=sale/table_kot/save_kot&token='.token,
        type: "POST",
        data: form_data,
        success: function(data) {
		    console.log(data);
		    data = JSON.parse(data);

            console.log(kots().get());
            console.log(kot_products().get());

            kots.insert(data.last_kot);
            kot_products.insert(data.last_kot_products);

            console.log(kots().get());
            console.log(kot_products().get());

            refresh_current_kot_list();

        }
    }).done(function() {
        while (my_cart.length) {
            my_cart.pop();
        }

    });
}

$("body").on("click", ".view_kot", function() {
    var kot_i = $(this).attr('data-kot-id');

    var kot_p = kot_products({
        kot_id: kot_i
    }).get();
    console.log(kot_i);
    console.log(kot_p);

    var html;

    for (var i = 0; i < kot_p.length; i++) {

        html += "<tr><td>" + kot_p[i].name + "</td><td>" + kot_p[i].quantity + "</td></tr>";

    }

    $("#kot_product_body").html(html);

    $("#myModal").modal();

})