<?php echo $header; ?><?php echo $column_left; ?>
<div id="content">
  <div class="page-header">
    <div class="container-fluid">
      <h1>Bar Stock Balance Entries</h1>
    
    </div>
  </div>
  
  
  <div class="container-fluid">
    <div class="panel panel-default">
      <div class="panel-heading">
        <h3 class="panel-title"><i class="fa fa-bar-chart"></i> Bar Purchase List</h3>
      </div>
      <div class="panel-body">
        <div class="well">
          <div class="row">
            <div class="col-sm-6">
              <div class="form-group">
                <label class="control-label" for="input-date-start"><?php echo $entry_date_start; ?></label>
                <div class="input-group date">
                  <input type="text" name="filter_date_start" value="<?php echo $filter_date_start; ?>" placeholder="<?php echo $entry_date_start; ?>" data-date-format="YYYY-MM-DD" id="input-date-start" class="form-control" />
                  <span class="input-group-btn">
                  <button type="button" class="btn btn-default"><i class="fa fa-calendar"></i></button>
                  </span></div>
              </div>
             </div>
             <div class="col-sm-6"> 
              <div class="form-group">
                <label class="control-label" for="input-date-end"><?php echo $entry_date_end; ?></label>
                <div class="input-group date">
                  <input type="text" name="filter_date_end" value="<?php echo $filter_date_end; ?>" placeholder="<?php echo $entry_date_end; ?>" data-date-format="YYYY-MM-DD" id="input-date-end" class="form-control" />
                  <span class="input-group-btn">
                  <button type="button" class="btn btn-default"><i class="fa fa-calendar"></i></button>
                  </span></div>
              </div>
            </div>
     <button type="button" id="button-filter" class="btn btn-primary pull-right"><i class="fa fa-filter"></i> <?php echo $button_filter; ?></button>
          </div>
        </div>
        <div class="table-responsive">
          <table class="table table-bordered">
            <thead>
              <tr>
                <td class="text-left">S.No.</td>
                <td class="text-left">Purchase By</td>
                <td class="text-right">Total</td>
                <td class="text-right">Date</td>
                <td class="text-right">Action</td>
       
              </tr>
            </thead>
            <tbody>
            
              <?php if ($results_p) { ?>
              <?php for ($i=0; $i<sizeof($results_p); $i++) { ?>
              <tr>
                <td class="text-left"><?php echo $i+1; ?></td>
                <td class="text-left"><?php echo $results_p[$i]['username']; ?></td>
                <td class="text-right"><?php echo $results_p[$i]['total_amount']; ?></td>
                <td class="text-right"><?php echo $results_p[$i]['date']; ?></td>
                <td class="text-right"><a style="cursor:pointer" data-toggle="modal" data-target="#myModal" class="modal_open" data-stock-id='<?php echo $results_p[$i]['stock_id']; ?>'>View</a></td>
          
              </tr>
              <?php } ?>
              <?php } else { ?>
              <tr>
                <td class="text-center" colspan="5"><?php echo $text_no_results; ?></td>
              </tr>
              <?php } ?>
            </tbody>
          </table>
        </div>
        <div class="row">
          <div class="col-sm-6 text-left"><?php echo $pagination; ?></div>
          <div class="col-sm-6 text-right"><?php echo $results; ?></div>
        </div>
      </div>
    </div>
  </div>
   <script type="text/javascript"><!--
$('#button-filter').on('click', function() {
	url = 'index.php?route=report/report_bar_consumption&token=<?php echo $token; ?>';
	
	var filter_date_start = $('input[name=\'filter_date_start\']').val();
	
	if (filter_date_start) {
		url += '&filter_date_start=' + encodeURIComponent(filter_date_start);
	}

	var filter_date_end = $('input[name=\'filter_date_end\']').val();
	
	if (filter_date_end) {
		url += '&filter_date_end=' + encodeURIComponent(filter_date_end);
	}
	
	
	location = url;
});
//--></script> 
  <script type="text/javascript"><!--
$('.date').datetimepicker({
	pickTime: false
});

$(".modal_open").click(function(){
	var stock_id = $(this).attr("data-stock-id");
       $.ajax({
		   url:"index.php?route=report/report_bar_consumption/get_products&token=<?php echo $token; ?>",
		   data:{"stock_id":stock_id},
		   type:"POST",
		     success: function(data){
				 data = JSON.parse(data);
				 console.log(data);
		      var html;
			  var j = 1;
			  for(var i =0; i<data.length; i++){
				html += "<tr><td>"+ j+"</td><td>"+ data[i]['name']+"</td><td>"+ data[i]['quantity']+"</td><td>"+ data[i]['price']+"</td><td>"+ data[i]['tax_rate']+"</td></tr>"; 
				j++;
				 }
			 $("#apen_data").html(html); 
				   
				   }
			   
			   
		   })
	})

//--></script> 
</div>

<div id="myModal" class="modal fade" role="dialog">
  <div class="modal-dialog">

    <!-- Modal content-->
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal">&times;</button>
        <h4 class="modal-title">Purchase Products</h4>
      </div>
      <div class="modal-body">
       <table class="table table-striped table-responsive">
      <thead>
       <tr><td>S. No.</td><td>Product Name</td><td>Qty</td><td>Price</td><td>Tax</td></tr>
      </thead>
      <tbody id="apen_data">
      
      </tbody>
       </table>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
      </div>
    </div>

  </div>
</div>

<?php echo $footer; ?>